from enum import Enum


class AccessType(Enum):
    """ Access type of the register """
    READ_WRITE = 0
    """ R/W configuration registers, burst access possible """
    COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS = 1
    """ Command Strobes, Status registers (read only) and multi byte registers"""


table_columns = ["Address", "Access Type", "Write Single Byte", "Write Burst",
                 "Read Single Byte", "Read Burst"]
table = [
    [0x00, AccessType.READ_WRITE, "IOCFG2", "IOCFG2", "IOCFG2", "IOCFG2"],
    [0x01, AccessType.READ_WRITE, "IOCFG1", "IOCFG1", "IOCFG1", "IOCFG1"],
    [0x02, AccessType.READ_WRITE, "IOCFG0", "IOCFG0", "IOCFG0", "IOCFG0"],
    [0x03, AccessType.READ_WRITE, "FIFOTHR", "FIFOTHR", "FIFOTHR", "FIFOTHR"],
    [0x04, AccessType.READ_WRITE, "SYNC1", "SYNC1", "SYNC1", "SYNC1"],
    [0x05, AccessType.READ_WRITE, "SYNC0", "SYNC0", "SYNC0", "SYNC0"],
    [0x06, AccessType.READ_WRITE, "PKTLEN", "PKTLEN", "PKTLEN", "PKTLEN"],
    [0x07, AccessType.READ_WRITE, "PKTCTRL1", "PKTCTRL1", "PKTCTRL1", "PKTCTRL1"],
    [0x08, AccessType.READ_WRITE, "PKTCTRL0", "PKTCTRL0", "PKTCTRL0", "PKTCTRL0"],
    [0x09, AccessType.READ_WRITE, "ADDR", "ADDR", "ADDR", "ADDR"],
    [0x0A, AccessType.READ_WRITE, "CHANNR", "CHANNR", "CHANNR", "CHANNR"],
    [0x0B, AccessType.READ_WRITE, "FSCTRL1", "FSCTRL1", "FSCTRL1", "FSCTRL1"],
    [0x0C, AccessType.READ_WRITE, "FSCTRL0", "FSCTRL0", "FSCTRL0", "FSCTRL0"],
    [0x0D, AccessType.READ_WRITE, "FREQ2", "FREQ2", "FREQ2", "FREQ2"],
    [0x0E, AccessType.READ_WRITE, "FREQ1", "FREQ1", "FREQ1", "FREQ1"],
    [0x0F, AccessType.READ_WRITE, "FREQ0", "FREQ0", "FREQ0", "FREQ0"],
    [0x10, AccessType.READ_WRITE, "MDMCFG4", "MDMCFG4", "MDMCFG4", "MDMCFG4"],
    [0x11, AccessType.READ_WRITE, "MDMCFG3", "MDMCFG3", "MDMCFG3", "MDMCFG3"],
    [0x12, AccessType.READ_WRITE, "MDMCFG2", "MDMCFG2", "MDMCFG2", "MDMCFG2"],
    [0x13, AccessType.READ_WRITE, "MDMCFG1", "MDMCFG1", "MDMCFG1", "MDMCFG1"],
    [0x14, AccessType.READ_WRITE, "MDMCFG0", "MDMCFG0", "MDMCFG0", "MDMCFG0"],
    [0x15, AccessType.READ_WRITE, "DEVIATN", "DEVIATN", "DEVIATN", "DEVIATN"],
    [0x16, AccessType.READ_WRITE, "MCSM2", "MCSM2", "MCSM2", "MCSM2"],
    [0x17, AccessType.READ_WRITE, "MCSM1", "MCSM1", "MCSM1", "MCSM1"],
    [0x18, AccessType.READ_WRITE, "MCSM0", "MCSM0", "MCSM0", "MCSM0"],
    [0x19, AccessType.READ_WRITE, "FOCCFG", "FOCCFG", "FOCCFG", "FOCCFG"],
    [0x1A, AccessType.READ_WRITE, "BSCFG", "BSCFG", "BSCFG", "BSCFG"],
    [0x1B, AccessType.READ_WRITE, "AGCCTRL2", "AGCCTRL2", "AGCCTRL2", "AGCCTRL2"],
    [0x1C, AccessType.READ_WRITE, "AGCCTRL1", "AGCCTRL1", "AGCCTRL1", "AGCCTRL1"],
    [0x1D, AccessType.READ_WRITE, "AGCCTRL0", "AGCCTRL0", "AGCCTRL0", "AGCCTRL0"],
    [0x1E, AccessType.READ_WRITE, "WOREVT1", "WOREVT1", "WOREVT1", "WOREVT1"],
    [0x1F, AccessType.READ_WRITE, "WOREVT0", "WOREVT0", "WOREVT0", "WOREVT0"],
    [0x20, AccessType.READ_WRITE, "WORCTRL", "WORCTRL", "WORCTRL", "WORCTRL"],
    [0x21, AccessType.READ_WRITE, "FREND1", "FREND1", "FREND1", "FREND1"],
    [0x22, AccessType.READ_WRITE, "FREND0", "FREND0", "FREND0", "FREND0"],
    [0x23, AccessType.READ_WRITE, "FSCAL3", "FSCAL3", "FSCAL3", "FSCAL3"],
    [0x24, AccessType.READ_WRITE, "FSCAL2", "FSCAL2", "FSCAL2", "FSCAL2"],
    [0x25, AccessType.READ_WRITE, "FSCAL1", "FSCAL1", "FSCAL1", "FSCAL1"],
    [0x26, AccessType.READ_WRITE, "FSCAL0", "FSCAL0", "FSCAL0", "FSCAL0"],
    [0x27, AccessType.READ_WRITE, "RCCTRL1", "RCCTRL1", "RCCTRL1", "RCCTRL1"],
    [0x28, AccessType.READ_WRITE, "RCCTRL0", "RCCTRL0", "RCCTRL0", "RCCTRL0"],
    [0x29, AccessType.READ_WRITE, "FSTEST", "FSTEST", "FSTEST", "FSTEST"],
    [0x2A, AccessType.READ_WRITE, "PTEST", "PTEST", "PTEST", "PTEST"],
    [0x2B, AccessType.READ_WRITE, "AGCTEST", "AGCTEST", "AGCTEST", "AGCTEST"],
    [0x2C, AccessType.READ_WRITE, "TEST2", "TEST2", "TEST2", "TEST2"],
    [0x2D, AccessType.READ_WRITE, "TEST1", "TEST1", "TEST1", "TEST1"],
    [0x2E, AccessType.READ_WRITE, "TEST0", "TEST0", "TEST0", "TEST0"],
    [0x2F, AccessType.READ_WRITE, "", "", "", ""],
    [0x30, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SRES", "", "SRES", "PARTNUM"],
    [0x31, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SFSTXON", "", "SFSTXON", "VERSION"],
    [0x32, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SXOFF", "", "SXOFF", "FREQEST"],
    [0x33, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SCAL", "", "SCAL", "LQI"],
    [0x34, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SRX", "", "SRX", "RSSI"],
    [0x35, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "STX", "", "STX", "MARCSTATE"],
    [0x36, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SIDLE", "", "SIDLE", "WORTIME1"],
    [0x37, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "", "", "", "WORTIME0"],
    [0x38, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SWOR", "", "SWOR", "PKTSTATUS"],
    [0x39, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SPWD", "", "SPWD", "VCO_VC_DAC"],
    [0x3A, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SFRX", "", "SFRX", "TXBYTES"],
    [0x3B, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SFTX", "", "SFTX", "RXBYTES"],
    [0x3C, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SWORRST", "", "SWORRST", "RCCTRL1_STATUS"],
    [0x3D, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "SNOP", "", "SNOP", "RCCTRL0_STATUS"],
    [0x3E, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "PATABLE", "PATABLE", "PATABLE", "PATABLE"],
    [0x3F, AccessType.COMMAND_STROBES_STATUS_REGISTERS_MULTI_BYTE_REGISTERS,
        "TX FIFO", "TX FIFO", "RX FIFO", "RX FIFO"]
]
